// Hue Tint
// Chris Hackmann
// PS 2.a
// Hue color tinter.

//#PARAM float hue 360 : Hue : Hue value
float hue;

//PARAM float saturation 1 : Saturation : Saturation value
//float saturation;

//PARAM float lightness 0.5 : Lightness : Lightness value
//float lightness;

// Foreground texture
texture ForegroundTexture;

// Background texture
texture BackgroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};

// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
    // Convert the HSL colors to RGB
    float4 front = tex2D(foreground, Tex.xy);
    float cmin;
    float cmax;
    float temp1;
    float temp2;
    float rtemp3;
    float gtemp3;
    float btemp3;
    float rc;
    float gc;
    float bc;
    float nl;
    float ns;
    float nh;

    cmin = min (front.r,front.g);
    cmin = min (cmin,front.b);
    cmax = max (front.r,front.g);
    cmax = max (cmax,front.b);

    nl = (cmax + cmin) / 2;

    if (cmax == cmin)
    {
        ns = 0;
        hue = 0;
    }

    if (nl < 0.5)
    {
        ns = (cmax - cmin) / (cmax + cmin);
    }
    else
    {
        ns = (cmax - cmin) / (2.0 - cmax - cmin);
    }

    if (front.r == cmax)
    {
        nh = ((front.g - front.b) / (cmax - cmin)) / 6;
    }

    if (front.g == cmax)
    {
        nh = (2.0 + (front.b - front.r) / (cmax - cmin)) / 6;
    }

    if (front.b == cmax)
    {
        nh = (4.0 + (front.r - front.g) / (cmax - cmin)) / 6;
    }

    hue = (hue / 360) + nh;
    
    if (hue > 1)
    {
        hue = hue - 1;
    }

    if (ns != 0)
    {
        if (nl < 0.5)
        {
            temp2 = nl * (1.0 + ns);
        }
        else
        {
            temp2 = nl + ns - nl * ns;
        }
        temp1 = 2.0 * nl - temp2;
        rtemp3 = hue + 1.0/3.0;
        gtemp3 = hue;
        btemp3 = hue - 1.0/3.0;

        //Lots of if statements
        if (rtemp3 < 0)
        {
            rtemp3 = rtemp3 + 1.0;
        }

        if (rtemp3 > 1)
        {
            rtemp3 = rtemp3 - 1.0;
        }

        if (gtemp3 < 0)
        {
            gtemp3 = gtemp3 + 1.0;
        }

        if (gtemp3 > 1)
        {
            gtemp3 = gtemp3 - 1.0;
        }

        if (btemp3 < 0)
        {
            btemp3 = btemp3 + 1.0;
        }

        if (btemp3 > 1)
        {
            btemp3 = btemp3 - 1.0;
        }

        //More if statements
        if (6.0 * rtemp3 < 1)
        {
            rc = temp1 + (temp2 - temp1) * 6.0 * rtemp3;
        }
        else if (2.0 * rtemp3 < 1)
        {
            rc = temp2;
        }
        else if (3.0 * rtemp3 < 2)
        {
            rc = temp1 + (temp2 - temp1) * ((2.0 / 3.0) - rtemp3) * 6.0;
        }
        else
        {
            rc = temp1;
        }

        //More if statements
        if (6.0 * gtemp3 < 1)
        {
            gc = temp1 + (temp2 - temp1) * 6.0 * gtemp3;
        }
        else if (2.0 * gtemp3 < 1)
        {
            gc = temp2;
        }
        else if (3.0 * gtemp3 < 2)
        {
            gc = temp1 + (temp2 - temp1) * ((2.0 / 3.0) - gtemp3) * 6.0;
        }
        else
        {
            gc = temp1;
        }

        //More if statements
        if (6.0 * btemp3 < 1)
        {
            bc = temp1 + (temp2 - temp1) * 6.0 * btemp3;
        }
        else if (2.0 * btemp3 < 1)
        {
            bc = temp2;
        }
        else if (3.0 * btemp3 < 2)
        {
            bc = temp1 + (temp2 - temp1) * ((2.0 / 3.0) - btemp3) * 6.0;
        }
        else
        {
            bc = temp1;
        }
        front.r = rc;
        front.g = gc;
        front.b = bc;
    }
    else
    {
        front.rgb = nl;
    }
    return front;
}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_a EffectProcess();    
    }
}
