// Noise
// Pawel Brzozowski
// PS 2.0
// Adds noise.


//#BORDER-MODE : prevents clipping to the bounding box area.
//#PARAM float Speed 1 : Speed  : Speed of noise.
//#PARAM float XSize 1 : X Size  : Noise horizontal size.
//#PARAM float YSize 1 : Y Size  : Noise vertical size.
//#PARAM percent Mod 1 : Modulation : Noise modulation.


float frameCounter; 
float XSize;
float YSize;
float Mod;
float Speed;


// Foreground texture
texture ForegroundTexture;


// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};



// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
	float2 t = Tex;		
	 float x = t.x * t.y * (frameCounter/Speed)-frameCounter;
	 x = fmod(x,Mod) * fmod(x,Mod);	
	 float dx = fmod(x,XSize/100);
	 float dy = fmod(x,YSize/100);
	 float4 c = tex2D(foreground, t + float2(dx,dy));		
	 return c;
} 

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}
